
%A=soybean2
A=wine
crit='NN';
%crit='maha-s'
%crit='in-in';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%forward search
[w,R]=featself(setprior(A,0),crit,[],[],1)
figure(3), clf, plot(R(:,1),R(:,2),'r-')

mx = max(R(:,2)); % best
who = find(R(:,2)==mx) ; % consider ties
[x,i]=min(R(who,1)); %smallest subset
hold on, plot(R(who(i),1), R(who(i),2),'ro')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%backward search
[w,R]=featselb(setprior(A,0),crit,[],[],1)
figure(3), plot(R(:,1),R(:,2),'g-')

mx = max(R(:,2)); % best
who = find(R(:,2)==mx) ; % consider ties
[x,i]=min(R(who,1)); %smallest subset
hold on, plot(R(who(i),1), R(who(i),2),'go')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%floating search
[w,R]=featselp(setprior(A,0),crit,[],[],1);

figure(3), plot(R(:,1),R(:,2))

mx = max(R(:,2)); % best
who = find(R(:,2)==mx) ; % consider ties
[x,i]=min(R(who,1)); %smallest subset
hold on, plot(R(who(i),1), R(who(i),2),'o')

xlabel('features')
ylabel('criterion')
legend({'SFS','SFS best', 'SBS','SBS best', 'SFFS','SFFS best'},'Location','SouthEast')
title(['Sequential Feature Selection (' getname(A) ')'])


